// ELIZA : Simuler un dialogue entre un psychiatre et un patient, bas sur le Pattern-Matching 
// Exemple de dialogue:
// Patient: Je suis toujours en dsaccord avec mes parents.
// Medecin: Etes-vous venu me voir parce que vous etes toujours en dsaccord avec vos parents ?
// Patient: Je pense que mes parents me detestent.
// Medecin: Dveloppez vos sentiments.
// ...
// - Je ne peux pas vous expliquer mon problme.
// - Est ce que vous avez peur de me raconter ce qui vous angoisse ?
// - Non.
// - Dites-vous non juste pour etre negatif ?
// - Non,
// - Vous etes un peu pessimiste !
// - vous etes gnial.
// - Qu'est-ce qui vous fait croire que je suis genial ?
// ...


// Analyse par pattern-matching utilise un dictionnaire de patterns: chaque entre d'un tel dictionnaire est un
// couple dont le premier lment est un pattern d'entre et le second lment une liste de patterns de sortie,
// si la phrase en entre match/s'apparie au pattern d'entre, un des patterns en sortie sera choisie comme rponse
// Notons qu'en gnral, les deux patterns E/S partagent des variables qui simulent l'esprit d'un dialogue ...

dict([y, "je", "ne", "peux", "pas", x, "problme", z, "."],
     [["est ce que vous avez peur de me raconter ce qui vous angoisse ?"],
      ["peut tre vous vous sentez angoiss de ", x, " problme", z]]).
dict([y, "je", "ne", "peux", "pas", x],
     [["vous n'aimez vraiment pas ", x],
      ["pourquoi ne voulez-vous pas ", x],
      ["souhaitez-vous pouvoir ", x],
      ["est-ce que cela vous ennuit"]]).
dict([y, "pere", x, "."],
     [["parlez-moi plus de votre famille"],
      ["qui encore dans votre famille", x]]).
dict([y, "mere", x, "."],
     [["parlez-moi plus de votre famille"],
      ["qui encore dans votre famille", x]]).
// ...
dict([x, "."],
     [["pouvez-vous etre plus explicite sur ce qui vous effraie ?"],
      ["qu'est-ce que cela vous suggere ?"],
      ["je vois"],
      ["je ne suis pas sur de bien vous comprendre"],
      ["continuez, soyez plus explicite"],
      ["pouvez-vous dvelopper ce point ?"],
      ["C'est trs interessant"]]).

// dict de certaines particules linguistiques
// dans un dialogue, on peut avoir: 
// - je te regarde
// - pourquoi me regarde tu ?
transforme("vous", "je").
transforme("etes", "suis").
transforme("suis", "etes").
// ...
transforme("me", "vous").
transforme("te", "me").

// Le but patternMatch est le coeur de l'application:
// TantQue la phrase en entre n'est pas "bye", faire:
// 1- chercher une entre dans le dict des patterns:
// 2- determine ensuite le rang de l'entre en sortie  activer
// 3- Afficher le pattern en sortie choisie en considrant les transformations des particules linguistiques
// 4- On m--j le rang afin de choisir la prochaine sortie 

// Le but match(phrase, pattern) est une variante/extension de l'unification de Prolog; il est dfini comme suit:
// 1- si on arrive au dernier lment du pattern et si on peut l'unifier avec le reste de la phrase, le matching 
//    se terminera alors avec succs.
// 2- si l'lment courant du pattern est une constante et qu'il est quivalent  l'lment courant de la phrase,
//    on poursuit alors le matching avec le reste de la phrase et du pattern.
// 3- si l'lment courant du pattern est une variable, l'lment courant doit s'instancier  la sous-liste de la //    phrase; cette sous-liste tant dlimite par l'lment suivant dans le pattern. On poursuit ensuite le
//    matching avec le reste de la phrase et du pattern.
// 4- Si aucun des cas prcdents ne russit, conclure l'chec du matching